package cz.cvut.fel.agents.pdv.student;

import cz.cvut.fel.agents.pdv.dsand.Message;
import cz.cvut.fel.agents.pdv.raft.RaftProcess;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.Queue;
import java.util.function.BiConsumer;

/**
 * Vasim ukolem bude naimplementovat (nejenom) tuto tridu. Procesy v klusteru pracuji s logy, kde
 * kazdy zanam ma podobu hash mapy - kazdy zaznam v logu by mel reprezentovat stav distribuovane
 * databaze v danem okamziku - po zpracovani pozadavku od klienta serverem.
 *
 * Vasi implementaci budeme testovat v ruznych scenarich - viz evaluation.RaftRun. Nasim cilem je,
 * abyste zvladli implementovat jednoduchou distribuovanou key/value databazi s garancemi podle
 * RAFT.
 */
public class ClusterProcess extends RaftProcess<Map<String, String>> {

  // ostatni procesy v klusteru
  private final List<String> otherProcessesInCluster;
  // maximalni spozdeni v siti
  private final int networkDelays;

  public ClusterProcess(String id, Queue<Message> inbox, BiConsumer<String, Message> outbox,
      List<String> otherProcessesInCluster, int networkDelays) {
    super(id, inbox, outbox);
    this.otherProcessesInCluster = otherProcessesInCluster;
    this.networkDelays = networkDelays;

  }

  @Override
  public Optional<Map<String, String>> getLastSnapshotOfLog() {
    return Optional.empty();
  }

  @Override
  public String getCurrentLeader() {

    return null;
  }

  @Override
  public void act() {

    // doimplementuje metodu act() podle RAFT

    // krome vlastnich zprav (vasich trid), dostavate typy zprav z balicku raft.messages s rodicem
    // ClientRequest, tak si je projdete, at vite, co je ucelem a obsahem jednotlivych typu.
    // V pripade ClientRequestWithContent dostavate zpravu typu
    // ClientRequestWithContent<StoreOperationEnums, Pair<String, String>>, kde StoreOperationEnums
    // je operace, ktery mate udelat s obsahem paru Pair<String, String>, kde prvni hodnota
    // paru je klic (nikdy neni prazdny) a druha je hodnota (v pripade pozadavku GET je prazdny)

    // na pozadavky klientu odpovidate zpravami typu ServerResponse viz popis podtypu v messages

    // dejte si pozor na jednotlive akce podle RAFT. S klientem komunikujte vyhradne pomoci zprav
    // typu ServerResponse v messages
  }
}
